package robust.PM;

import android.app.Activity;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;

public class Login extends Activity {
	/** Called when the activity is first created. */
	
	private String input_id = "";
	private String input_password = "";
	
	private String cheak_id = "";
	private String cheak_password = "";
	
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.login);
		
		// EditText, Button 생성
		final EditText id = (EditText) findViewById(R.id.et_Id);
		final EditText password = (EditText) findViewById(R.id.et_Password);
		final Button button = (Button) findViewById(R.id.btn_Login);
		final TextView creator = (TextView) findViewById(R.id.tv_Creator);
		
		// creator 클릭
		creator.setOnClickListener(new View.OnClickListener() {
			
			@Override
			public void onClick(View v) {
				startActivity(new Intent(Login.this, Creators.class));
				
			}
		});
		
		// 로그인 정보를 저장하는 SharedPreferences 생성
		SharedPreferences member = getSharedPreferences("member", MODE_PRIVATE);

		id.setText(member.getString("mem_id", ""));
		password.setText(member.getString("mem_password", ""));
				
		// 로그인 버튼 클릭
		button.setOnClickListener(new View.OnClickListener() {
			public void onClick(View v) {
				
				// 텍스트박스의 내용을 입력받는다
				input_id = id.getText().toString();
				input_password = password.getText().toString();
				
				// 아이디와 패스워드를 체크한다
				cheak_id = DBHelper.getID(input_id);
				cheak_password = DBHelper.getPassword(input_id);
				
				button.setSelected(true);
				
				Toast.makeText(Login.this, cheak_id, Toast.LENGTH_SHORT).show();
				Toast.makeText(Login.this, cheak_password, Toast.LENGTH_SHORT).show();

				if ( input_id.equals("") || input_id.equals("") )	{
					Toast.makeText( Login.this, "잘못 입력하셨습니다.", Toast.LENGTH_SHORT).show();
				} else if ( input_id.equals(cheak_id) && input_password.equals(cheak_password) ) {
					startActivity(new Intent(Login.this, Project.class));
				} else {
					Toast.makeText(Login.this, "아이디와 패스워드를 확인하세요", Toast.LENGTH_SHORT).show();
				}
			}
		});
	}

	@Override
	protected void onResume() {
		super.onResume();
		
		// EditText, Button 생성
		final EditText id = (EditText) findViewById(R.id.et_Id);
		final EditText password = (EditText) findViewById(R.id.et_Password);
		
		// 로그인 정보를 저장하는 SharedPreferences 생성
		SharedPreferences member = getSharedPreferences("member", MODE_PRIVATE);

		id.setText(member.getString("mem_id", ""));
		password.setText(member.getString("mem_password", ""));
	}

	@Override
	protected void onPause() {
		super.onPause();
		
		// EditText, Button 생성
		final EditText id = (EditText) findViewById(R.id.et_Id);
		final EditText password = (EditText) findViewById(R.id.et_Password);
		
		SharedPreferences member = getSharedPreferences("member", MODE_PRIVATE);
		// SharedPreferences 수정할수 있는 에디터를 불러온다
		SharedPreferences.Editor editor = member.edit();

		// editor를 사용하여 pref에 id와 password 저장
		editor.putString("mem_id", id.getText().toString());
		editor.putString("mem_password", password.getText().toString());

		editor.commit();
	}
}