package robust.PM;

import java.util.ArrayList;

import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.Toast;

public class Project extends Activity {

	static final int PROGRESS_DIALOG = 0;
	ProgressDialog progressDialog = null;
	
	private ArrayAdapter<String> proj_adapter;
	private ArrayList<String> project = new ArrayList<String>();
	private ListView projView;

	private String projName [] = new String[10];

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.project);

		// 로딩 다이얼로그 시작
		ProgressDialog dialog = ProgressDialog.show(this, "", "Loading. Please wait...", true);
		dialog.show();
		
		// 로그인 정보를 저장하는 SharedPreferences 생성
		SharedPreferences member = getSharedPreferences("member", MODE_PRIVATE);
		String mem_id = member.getString("mem_id", "");
		
		proj_adapter = new ArrayAdapter<String>(this,
				android.R.layout.simple_list_item_single_choice, project);
		projView = (ListView) findViewById(R.id.project);
		projView.setAdapter(proj_adapter);
		projView.setChoiceMode(ListView.CHOICE_MODE_SINGLE);

		DBHelper.getProject(mem_id, project, projName);

		projView.setOnItemClickListener(new AdapterView.OnItemClickListener() {
			public void onItemClick(AdapterView<?> parent, View view, int position, long id){
				Toast.makeText(Project.this, projName[position], Toast.LENGTH_SHORT).show();
				Intent intent = new Intent(Project.this, TaskList.class);
				intent.putExtra("PROJ_ID", position);
				startActivity(intent);
				
			}
		});
		
		// 로딩 다이얼로그 종료
		dialog.cancel();
	}
}