package robust.PM;

import java.util.ArrayList;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ListView;
import android.widget.TextView;

public class TaskList extends Activity {

	private ArrayList<MyItem> arItem;
	
	private int proj_id;

	// 최대 50개의 테스크를 가질수 있다
	private String taskDate [] = new String[50];
	private String taskName [] = new String[50];
	private String taskDetail [] = new String[50];
	
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.task);

		// 로그인 정보를 저장하는 SharedPreferences 생성
		SharedPreferences member = getSharedPreferences("member", MODE_PRIVATE);
		String mem_id = member.getString("mem_id", "");
		
		arItem = new ArrayList<MyItem>();
		
		MyListAdapter MyAdapter = new MyListAdapter( this, R.layout.tasktext, arItem );

		ListView MyList;
		MyList = (ListView)findViewById(R.id.task);
		
		// Project에서 넘어온 intent에서 proj_id를 추출 
		Intent intent = getIntent();
		proj_id = intent.getIntExtra("PROJ_ID", 0);
		
		// proj_id를 통해서 업무를 업무를 업데이트
		getTask(mem_id, proj_id);
		
		MyList.setAdapter(MyAdapter);

	}

	public void getTask(String ID, int proj_id){
		
		try{
			//서버에서 DB를 가져옮
			String jString = DBHelper.getHttpContents
			("http://203.253.27.222:80/service/moblie/json.jsp?userID="+ID);
			
			//JSONObject 얻어 오기 
			JSONObject  jObject =  new JSONObject(jString); 

			//JSONArray에 Project 값 넣어주기
			JSONArray jProj = new JSONArray(jObject.getString("Project"));

			//JSONArray에 Task 값 넣어주기
			JSONArray jTask = new JSONArray(jProj.getJSONObject(proj_id).getString("Task").toString());

			for(int b = 0; b < jTask.length(); b++){
				taskDate[b] = jTask.getJSONObject(b).getString("Task_date").toString();
				taskName[b] = jTask.getJSONObject(b).getString("Task_name").toString();
				//taskDetail[b] = jTask.getJSONObject(b).getString("Task_detail").toString();
				
				arItem.add(new MyItem( taskDate[b], taskName[b], taskDetail[b]));
			}
			
		} catch(JSONException je){ 
			Log.e("jsonErr", "JSON에러 입니다", je);
		} catch(Exception e){ 
			Log.e("execption", "파일이 없습니다", e);
		} 
	}
}

// 리스트뷰에 출력할 항목
class MyItem {
	MyItem(String tDate, String tName, String tDetail) {
		Date = tDate;
		Name = tName;
		Detail = tDetail;
	}
	String Date;
	String Name;
	String Detail;
}

// 어댑터 클래스
class MyListAdapter extends BaseAdapter {
	Context maincon;
	LayoutInflater Inflater;
	ArrayList<MyItem> arSrc;
	int layout;
	
	public MyListAdapter(Context context, int alayout, ArrayList<MyItem> aarSrc ) {
		maincon = context;
		Inflater = (LayoutInflater)context.getSystemService( Context.LAYOUT_INFLATER_SERVICE);
		arSrc = aarSrc;
		layout = alayout;
	}

	public int getCount() {
		return arSrc.size();
	}
	
	public String getItem( int position ) {
		return arSrc.get(position).Name;
	}
	
	public long getItemId( int position ) {
		return position;
	}
	
	public View getView( int position, View convertView, ViewGroup parent ) {

		if (convertView == null ) {
			convertView = Inflater.inflate(layout, parent, false );
		}
		
		TextView date = (TextView)convertView.findViewById(R.id.task_date);
		date.setText(arSrc.get(position).Date);
		
		TextView name = (TextView)convertView.findViewById(R.id.task_name);
		name.setText(arSrc.get(position).Name);
		
		TextView detail = (TextView)convertView.findViewById(R.id.task_detail);
		detail.setText(arSrc.get(position).Detail);
		
		return convertView;
	}
}