package robust.pm.android;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;

import robust.pm.dbmanager.DBCPConn;
import robust.pm.task.entity.task_memEntity;

public class task_memDAO {
	public boolean insertDB(task_memEntity task_mem) {
		Connection conn = null;
		PreparedStatement pstmt = null;
		
		String sql = "insert into ttask_mem(user_id, project_id, task_no) values(?,?,?)";

		try {
			conn = DBCPConn.getConnection("pool");
			pstmt = conn.prepareStatement(sql);
			pstmt.setString(1, task_mem.getUser_id());
			pstmt.setInt(2, task_mem.getProject_id());
			pstmt.setInt(3, task_mem.getTask_no());
			
			pstmt.executeUpdate();
		} catch (SQLException e) {
			e.printStackTrace();
			return false;
		} finally {
			try{
				pstmt.close();
				conn.close();
			}catch(SQLException sx) {}
		}

		return true;
	}

	//̺ Ư    ٰ Ǵؼ ּ ó . -2010.10.03 -
/*	public boolean updateDB(task_memEntity task_mem) {
		connect();

		String sql = "update ttask_mem set user_id=?, project_id=?, task_no=? where part_no=?";
	
		try {
			pstmt = conn.prepareStatement(sql);
			pstmt.setInt(1,task_mem.getPart_no());
			pstmt.setInt(2, task_mem.getUser_id());
			pstmt.setInt(3, task_mem.getProject_id());
			pstmt.setInt(4, task_mem.getTask_no());
			pstmt.executeUpdate();
		} catch (SQLException e) {
			e.printStackTrace();
			return false;
		} finally {
			disconnect();
		}

		return true;
	}*/

	// Խù ϱ  ޼
	public boolean deleteDB(int task_no) {
		Connection conn = null;
		PreparedStatement pstmt = null;

		String sql = "delete from ttask_mem where task_no=?";

		try {
			conn = DBCPConn.getConnection("pool");
			pstmt = conn.prepareStatement(sql);
			pstmt.setInt(1, task_no);
			pstmt.executeUpdate();
		} catch (SQLException e) {
			e.printStackTrace();
			return false;
		} finally {
			try{
				pstmt.close();
				conn.close();
			}catch(SQLException sx) {}
		}

		return true;
	}

	public task_memEntity get_UserDB(int part_no) {
		Connection conn = null;
		PreparedStatement pstmt = null;

		String sql = "select * from ttask_mem where part_no=?";
		task_memEntity task_mem = new task_memEntity();

		try {
			conn = DBCPConn.getConnection("pool");
			pstmt = conn.prepareStatement(sql);
			pstmt.setInt(1, part_no);
			ResultSet rs = pstmt.executeQuery();			
			rs.next();
			task_mem.setPart_no(rs.getInt("part_no"));
			task_mem.setUser_id(rs.getString("user_id"));
			task_mem.setProject_id(rs.getInt("project_id"));
			task_mem.setTask_no(rs.getInt("task_no"));
			rs.close();
		} catch (SQLException e) {
			e.printStackTrace();
		} finally {
			try{
				pstmt.close();
				conn.close();
			}catch(SQLException sx) {}
		}

		return task_mem;
	}

	//˻  Project_id ʿ Ѱ Ƽ ߰  -2010.10.03 -
	public ArrayList<task_memEntity> get_UserDBList(int project_id, int task_no) {
		Connection conn = null;
		PreparedStatement pstmt = null;
		
		ArrayList<task_memEntity> datas = new ArrayList<task_memEntity>();

		String sql = "select * from ttask_mem where project_id=? and task_no=?";

		try {
			conn = DBCPConn.getConnection("pool");
			pstmt = conn.prepareStatement(sql);
			pstmt.setInt(1, project_id);
			pstmt.setInt(2, task_no);
			
			ResultSet rs = pstmt.executeQuery();			

			while (rs.next()) {
				task_memEntity task_mem = new task_memEntity();

				task_mem.setPart_no(rs.getInt("part_no"));
				task_mem.setUser_id(rs.getString("user_id"));
				task_mem.setProject_id(rs.getInt("project_id"));
				task_mem.setTask_no(rs.getInt("task_no"));
				datas.add(task_mem);
			}
			rs.close();

		} catch (SQLException e) {
			e.printStackTrace();
		} finally {
			try{
				pstmt.close();
				conn.close();
			}catch(SQLException sx) {}
		}

		return datas;
	}
}