package robust.pm.glossary;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;

import robust.pm.dbmanager.DBCPConn;
import robust.pm.glossary.GlossaryBook;


public class GlossaryBean{
	//ͺ̽    
	private Connection conn = null;
	private PreparedStatement pstmt = null;


	//ͺ̽    ڿ 
	private String jdbc_driver = "com.mysql.jdbc.Driver";
	private String jdbc_url = "jdbc:mysql://localhost:3306/robust";

	void connect() {
		//JDBC ̹ ε
		try {
			Class.forName(jdbc_driver); //ε
			//ͺ̽  ̿ connection νϽ Ȯ
			conn = (Connection) DriverManager.getConnection(jdbc_url,
					"robust", "robust"); //
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	void disconnect() {
		if (pstmt != null) {
			try {
				pstmt.close();
			} catch (SQLException e) {
				e.printStackTrace();
			}
		}
		if (conn != null) {
			try {
				conn.close();
			} catch (SQLException e) {
				e.printStackTrace();
			}
		}
	}
	 /*encode(8859-1 -> KSC5601)*/
    public String toKor(String data){
        if(data == null)return data;
        String temp = "";
        try{
            temp = new String(
                   data.getBytes("8859_1"),"KSC5601");
        }catch(java.io.UnsupportedEncodingException uee){}
        return temp;
    }



	public boolean insertDB(GlossaryBook glossary) {
		//connect();
		//ϴ entity ּóѰ͵ Ƚ!
		String sql = "insert into tglossary(glossary_num,glossary_en,glossary_kr,glossary_contents) values(?,?,?,?)";

		try {
			conn = DBCPConn.getConnection("pool");
			
			pstmt = conn.prepareStatement(sql);
			
			pstmt.setInt(1, glossary.getGlossary_num());
			pstmt.setString(2, glossary.getGlossary_en());
			pstmt.setString(3, glossary.getGlossary_kr());
			pstmt.setString(4, glossary.getGlossary_contents());
			System.out.println(sql);
			System.out.println(glossary.getGlossary_num());
			System.out.println(glossary.getGlossary_en());
			System.out.println(glossary.getGlossary_contents());
			System.out.println(glossary.getGlossary_contents());
			
			
			pstmt.executeUpdate();
		} catch (SQLException e) {
			e.printStackTrace();
			return false;
		} finally {
			//disconnect();
			try{
				pstmt.close();
				conn.close();
			}catch(SQLException sx) {}
		}

		return true;
	}


	//̹ Ǿ ִ  ϴ 
	public boolean updateDB(GlossaryBook glossary) {
		//connect();

		String sql = "update tglossary set glossary_en=?, glossary_kr=?, glossary_contents=? where glossary_num=?";

		try {
			conn = DBCPConn.getConnection("pool");
			pstmt = conn.prepareStatement(sql);
			
			pstmt.setString(1, glossary.getGlossary_en());
			pstmt.setString(2, glossary.getGlossary_kr());
			pstmt.setString(3, glossary.getGlossary_contents());
			pstmt.setInt(4, glossary.getGlossary_num());
		

			
			pstmt.executeUpdate();
		} catch (SQLException e) {
			e.printStackTrace();
			return false;
		} finally {
			//disconnect();
			try{
				pstmt.close();
				conn.close();
			}catch(SQLException sx) {}
		}

		return true;
	}


	// Խù ϱ  ޼
	public boolean deleteDB(int glossary_num) {
		//connect();

		String sql = "delete from tglossary where glossary_num=?";

		try {
			conn = DBCPConn.getConnection("pool");
			pstmt = conn.prepareStatement(sql);
			pstmt.setInt(1, glossary_num);
			pstmt.executeUpdate();
		} catch (SQLException e) {
			e.printStackTrace();
			return false;
		} finally {
			//disconnect();
			try{
				pstmt.close();
				conn.close();
			}catch(SQLException sx) {}
		}

		return true;
	}


	
	////߿ ڵ Ǵ ̺  Է½ߵ!!!><><><//////
	public GlossaryBook getDB(int glossary_num) {
		//connect();

		String sql = "select * from tglossary where glossary_num=?";
		GlossaryBook glossary = new GlossaryBook();

		try {
			conn = DBCPConn.getConnection("pool");
			pstmt = conn.prepareStatement(sql);
			pstmt.setInt(1, glossary_num);
			ResultSet rs = pstmt.executeQuery();			
			rs.next();
			glossary.setGlossary_num(rs.getInt("glossary_num"));
			glossary.setGlossary_en(rs.getString("glossary_en"));
			glossary.setGlossary_kr(rs.getString("glossary_kr"));
			glossary.setGlossary_contents(rs.getString("glossary_contents"));
			rs.close();
		} catch (SQLException e) {
			e.printStackTrace();
		} finally {
			//disconnect();
			try{
				pstmt.close();
				conn.close();
			}catch(SQLException sx) {}
		}

		return glossary;
	}

	//Խù  ֱ  ϴ ż(͸ Ѳ ´)
	public ArrayList getDBList() {
		//connect();
		ArrayList<GlossaryBook> datas = new ArrayList<GlossaryBook>();

		String sql = "select * from tglossary ";

		try {
			conn = DBCPConn.getConnection("pool");
			pstmt = conn.prepareStatement(sql);
			ResultSet rs = pstmt.executeQuery();

			while (rs.next()) {
				GlossaryBook glossary = new GlossaryBook();

				glossary.setGlossary_num(rs.getInt("glossary_num"));
				glossary.setGlossary_en(rs.getString("glossary_en"));
				glossary.setGlossary_kr(rs.getString("glossary_kr"));
				glossary.setGlossary_contents(rs.getString("glossary_contents"));
				datas.add(glossary);
			}
			rs.close();

		} catch (SQLException e) {
			e.printStackTrace();
		} finally {
			//disconnect();
			try{
				pstmt.close();
				conn.close();
			}catch(SQLException sx) {}
		}

		return datas;
	}
}
