package robust.pm.logger;

/*******************************************************************
 * 1.class             : LogWriter.java
 * 2.class          : Thread ̿ 뷮 αó
 *  - 1. α Ͻ ýۿ ϸ ּȭѴ.
 * 3. ̺          : 
 *******************************************************************/


import java.io.File;

import robust.pm.property.CSProperty;
import robust.pm.util.DateFormat4Performance;


/**
 * 뷮 α   Logger 
 * 
 * ֿ
 * <LI> 1. ť(޸) α  </LI>
 * <LI> 2. α Ʈ  </LI>
 * <LI> 3. Thread ̿ 뷮 α  </LI>
 * 
 * 
 * @author daumsoft
 *
 */
public class LogWriter {
	
	/**
	 *  α  丮
	 */
	private static final String ERR_LOG_DIR = CSProperty.getInstance().getValue("ERROR_LOG_DIR");
	
    /** ̱水ü  */
    private static LogWriter  logInstance;
    /** ̱ ü  */
    private static boolean    m_bIsLoad    = false;
    
    /** α׷ */
    public static class LEVEL {
        /** ߽ Debug  αױ */
        public static final int    DEBUG    = 1;
        /** ø̼    */
        public static final int    INFO    = 2;
        /** ø̼ ࿡  ,  Ǵ ý ڿ  */
        public static final int    WARNING    = 3;
        /** ø̼   Ȳ  α */
        public static final int    ERROR    = 4;
        /** LEVEL 
         * ǻ : LEVELǵ ׸ INDEX ġ
         */
        public static final String[] LABEL = {
            ""
            , "DEBUG"       // DEBUG
            , "INFO"        // INFO
            , "WARNING"     // WARNING
            , "ERROR"       // ERROR
        };
    }
    
    /** α   */
    private LogWriterThread    logThread     = null;
    
    /** α  Thread  ϱ  Wrapping */
    private Thread            threadDaemon    = null;
    
    /**
     *  : ܺο Ƿ  ϰ Ѵ.
     */
    private LogWriter() {
    	
    }
    
    /**
     * <code>load</code> LogWriter ü Ѵ.
     */ 
    public synchronized static boolean load() {
    
        /** α Thread Ѵ. */
        if(m_bIsLoad == false) {
            logInstance = new LogWriter();
            
            /** Log   Instance  */
            logInstance.logThread = new LogWriterThread();
            
            /** Log   */
            logInstance.threadDaemon = new Thread(logInstance.logThread);
            logInstance.threadDaemon.setDaemon(true);
            logInstance.threadDaemon.start();
            
            /** ε  */
            m_bIsLoad = true;
            
            return true;
        } 
        else {
            return false;
        }
    }
    
    /**
     * <code>getInstance</code> ̱  LogWriter ü Ѵ.
     * LogWriter ü ȯѴ.
    * @ return        LogWriter
    */
    public static LogWriter getInstance() {

        if(m_bIsLoad == false)    load();

        return logInstance;
    }
       
    /**
     * <code>log</code> PointServer ۿ   α׸ Ѵ.
     * @param     sDir     log dir
     * @param     cName    Class Name
     * @param     mName    Method Name
     * @param     msg      α  ޽
     */
    public void log(String sDir, int level, String cName, String mName, String msg) {
    
        String sFileName = sDir + File.separator  + DateFormat4Performance.getCurrentTimestampString().substring(0, 8) + ".log";
        
        switch(level) {
            case LogWriter.LEVEL.DEBUG:
                LogWriter.getInstance().logThread.runIt(sFileName, cName, mName, LogWriter.LEVEL.LABEL[LogWriter.LEVEL.DEBUG], Thread.currentThread().getName(), msg);
                break;
            case LogWriter.LEVEL.INFO:
                LogWriter.getInstance().logThread.runIt(sFileName, cName, mName, LogWriter.LEVEL.LABEL[LogWriter.LEVEL.INFO], Thread.currentThread().getName(), msg);
                break;
            case LogWriter.LEVEL.WARNING:
                LogWriter.getInstance().logThread.runIt(sFileName, cName, mName, LogWriter.LEVEL.LABEL[LogWriter.LEVEL.WARNING], Thread.currentThread().getName(), msg);
                break;
            case LogWriter.LEVEL.ERROR:
                LogWriter.getInstance().logThread.runIt(sFileName, cName, mName, LogWriter.LEVEL.LABEL[LogWriter.LEVEL.ERROR], Thread.currentThread().getName(), msg);
                break;
        }
        return;
    }
    
    /**
     * <code>write</code>
     * @param    sDir    α׸  ش 丮
     * @param    e       ش Exception
     */
    public void log(String sDir, int level, Throwable e) {
    
        String sFileName = sDir + File.separator  + DateFormat4Performance.getCurrentTimestampString().substring(0, 8) + ".log";
        
        switch(level) {
            case LogWriter.LEVEL.DEBUG:
                LogWriter.getInstance().logThread.runIt(sFileName, LogWriter.LEVEL.LABEL[LogWriter.LEVEL.DEBUG], Thread.currentThread().getName(), e);
                break;
            case LogWriter.LEVEL.INFO:
                LogWriter.getInstance().logThread.runIt(sFileName, LogWriter.LEVEL.LABEL[LogWriter.LEVEL.INFO], Thread.currentThread().getName(), e);
                break;
            case LogWriter.LEVEL.WARNING:
                LogWriter.getInstance().logThread.runIt(sFileName, LogWriter.LEVEL.LABEL[LogWriter.LEVEL.WARNING], Thread.currentThread().getName(), e);
                break;
            case LogWriter.LEVEL.ERROR:
                LogWriter.getInstance().logThread.runIt(sFileName, LogWriter.LEVEL.LABEL[LogWriter.LEVEL.ERROR], Thread.currentThread().getName(), e);
                break;
        }
        return;
    } 
    
    /**
     * <code>write</code>
     * @param    sDir    α׸  ش 丮
     * @param    e       ش Exception
     */
    public void log(int level, Throwable e) {
    
        String sFileName = ERR_LOG_DIR + File.separator  + DateFormat4Performance.getCurrentTimestampString().substring(0, 8) + ".log";
        
        switch(level) {
            case LogWriter.LEVEL.DEBUG:
                LogWriter.getInstance().logThread.runIt(sFileName, LogWriter.LEVEL.LABEL[LogWriter.LEVEL.DEBUG], Thread.currentThread().getName(), e);
                break;
            case LogWriter.LEVEL.INFO:
                LogWriter.getInstance().logThread.runIt(sFileName, LogWriter.LEVEL.LABEL[LogWriter.LEVEL.INFO], Thread.currentThread().getName(), e);
                break;
            case LogWriter.LEVEL.WARNING:
                LogWriter.getInstance().logThread.runIt(sFileName, LogWriter.LEVEL.LABEL[LogWriter.LEVEL.WARNING], Thread.currentThread().getName(), e);
                break;
            case LogWriter.LEVEL.ERROR:
                LogWriter.getInstance().logThread.runIt(sFileName, LogWriter.LEVEL.LABEL[LogWriter.LEVEL.ERROR], Thread.currentThread().getName(), e);
                break;
        }
        return;
    } 
        
    /**
     * LogManager ׽Ʈ
     */
    /*
    public static void main(String[] argv) {
    	LogWriter logWriter = LogWriter.getInstance();
    	
    	logWriter.log("C:\\project\\helperdev\\logs", LogWriter.LEVEL.DEBUG, new Exception("߻"));
    	
    	for(int i = 0; i < 1000; i++) {
    		System.out.println(i + "° ");
    		
    		if(i == 10)
    			logWriter.log("C:\\project\\helperdev\\logs", LogWriter.LEVEL.DEBUG, new Exception("߻"));
    		
    		try {Thread.sleep(10000L);} catch (Exception e) {}
    	}
    }
    */
}

