package robust.pm.member;


import java.io.IOException;
import java.util.HashMap;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;


public class MemServlet extends HttpServlet {
	private HashMap<String, Command> commands;
	private String error = "/error.jsp";

	
	public void init(ServletConfig config) throws ServletException {
		super.init(config);
		initCommands();
		
		
	}
	
	public void service(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException
	{
		String next;
		try{
		
			Command cmd = lookupCommand(req.getParameter("cmd"));
			
			next = cmd.execute(req);
			CommandToken.set(req);
		}
		catch (CommandException e) {
			req.setAttribute("javax.servlet.jsp.jspException", e);
			next = error;
		}
		RequestDispatcher rd;
		rd = getServletContext().getRequestDispatcher(next);
		rd.forward(req, res);
	}
	
	private Command lookupCommand(String cmd) throws CommandException
	{
		System.out.println("!"+cmd+"!");
		if (cmd == null)
			cmd = "nullcommand";
		
		
		if (commands.containsKey(cmd.toLowerCase()))
			return (Command)commands.get(cmd.toLowerCase());
		else
			throw new CommandException("Invalid Command Identifier");
		
	}
	private void initCommands() {
		commands = new HashMap<String, Command>();
		
		commands.put("init", new InitCommand("/service/project/member/Member.jsp"));
		commands.put("search", new SearchCommand("/service/project/member/Member.jsp"));
		commands.put("nullcommand", new InitCommand("/service/project/member/Member.jsp"));
		commands.put("nextpage", new NextCommand("/service/project/task/task.jsp"));
		
	}
	
}
