package robust.pm.notice.service;

import java.sql.Connection;
import java.sql.SQLException;

import robust.pm.notice.dao.qArticleDao;
import robust.pm.notice.model.qDeleteRequest;
import robust.pm.dbmanager.*;

public class qDeleteArticleService {

	private static qDeleteArticleService instance = new qDeleteArticleService();

	public static qDeleteArticleService getInstance() {
		return instance;
	}

	private qDeleteArticleService() {
	}

	public void deleteArticle(qDeleteRequest deleteRequest)
			throws qArticleNotFoundException, qInvalidPasswordException {
		Connection conn = null;
		try {
			conn = DBCPConn.getConnection("pool");
			conn.setAutoCommit(false);
			qArticleCheckHelper checkHelper = new qArticleCheckHelper();
			//System.out.println(deleteRequest.getArticleId());
			checkHelper.checkExistsAndPassword(conn, deleteRequest
					.getArticleId(), deleteRequest.getPassword());
			
			
			qArticleDao articleDao = qArticleDao.getInstance();
			articleDao.delete(conn, deleteRequest.getArticleId());

			conn.commit();
		} catch (SQLException e) {
			JdbcUtil.rollback(conn);
			throw new RuntimeException(e);
		} catch (qArticleNotFoundException e) {
			JdbcUtil.rollback(conn);
			throw e;
		} catch (qInvalidPasswordException e) {
			JdbcUtil.rollback(conn);
			throw e;
		} finally {
			if (conn != null) {
				try {
					conn.setAutoCommit(true);
				} catch (SQLException e) {
				}
			}
			JdbcUtil.close(conn);
		}
	}
}
