package robust.pm.notice.service;

import java.sql.Connection;
import java.sql.SQLException;

import robust.pm.notice.dao.*;
import robust.pm.notice.model.*;
import robust.pm.dbmanager.*;

public class qReadArticleService {
	private static qReadArticleService instance = new qReadArticleService();
	public static qReadArticleService getInsteance() {
		return instance;
	}

	private qReadArticleService() {
	}

	public qArticle readArticle(int articleId) throws qArticleNotFoundException {
		return selectArticle(articleId, true);
	}

	private qArticle selectArticle(int articleId, boolean increaseCount)
			throws qArticleNotFoundException {
		Connection conn = null;
		try {
			conn = DBCPConn.getConnection("pool");
			qArticleDao articleDao = qArticleDao.getInstance();
			qArticle article = articleDao.selectById(conn, articleId);
			if (article == null) {
				throw new qArticleNotFoundException(
						"Խñ  ʽϴ : " + articleId);
			}
			if (increaseCount) {
				articleDao.increaseReadCount(conn, articleId);
				article.setReadCount(article.getReadCount() + 1);
			}
			return article;
		} catch (SQLException e) {
			throw new RuntimeException("DB  ߻: " + e.getMessage(), e);
		} finally {
			JdbcUtil.close(conn);
		}
	}

	public qArticle getArticle(int articleId) throws qArticleNotFoundException {
		return selectArticle(articleId, false);
	}
}
