package robust.pm.notice.service;

import java.sql.Connection;
import java.sql.SQLException;

import robust.pm.dbmanager.DBCPConn;

import robust.pm.notice.dao.*;
import robust.pm.notice.model.*;
import robust.pm.dbmanager.*;

public class qUpdateArticleService {

	private static qUpdateArticleService instance = new qUpdateArticleService();

	public static qUpdateArticleService getInstance() {
		return instance;
	}

	private qUpdateArticleService() {
	}

	public qArticle update(qUpdateRequest updateRequest)
			throws qArticleNotFoundException, qInvalidPasswordException {
		Connection conn = null;
		try {
			conn = DBCPConn.getConnection("pool");
			conn.setAutoCommit(false);

			qArticleCheckHelper checkHelper = new qArticleCheckHelper();
			checkHelper.checkExistsAndPassword(conn, updateRequest
					.getArticleId(), updateRequest.getPassword());

			qArticle updatedArticle = new qArticle();
			updatedArticle.setId(updateRequest.getArticleId());
			updatedArticle.setTitle(updateRequest.getTitle());
			updatedArticle.setContent(updateRequest.getContent());

			qArticleDao articleDao = qArticleDao.getInstance();
			int updateCount = articleDao.update(conn, updatedArticle);
			if (updateCount == 0) {
				throw new qArticleNotFoundException(
				"Խñ  ʽϴ : " + updateRequest.getArticleId());
			}

			qArticle article = articleDao.selectById(conn, updateRequest
					.getArticleId());

			conn.commit();

			return article;
		} catch (SQLException e) {
			JdbcUtil.rollback(conn);
			throw new RuntimeException("DB  ߻:" + e.getMessage(), e);
		} catch (qArticleNotFoundException e) {
			JdbcUtil.rollback(conn);
			throw e;
		} catch (qInvalidPasswordException e) {
			JdbcUtil.rollback(conn);
			throw e;
		} finally {
			if (conn != null) {
				try {
					conn.setAutoCommit(true);
				} catch (SQLException e) {
				}
				JdbcUtil.close(conn);
			}
		}
	}

}
