package robust.pm.timesheet;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;

import robust.pm.dbmanager.DBCPConn;
import robust.pm.timesheet.TimesheetEntity;


public class TimesheetDAO {
	//ͺ̽    
	private Connection conn = null;
	private PreparedStatement pstmt = null;

	public boolean insertDB(TimesheetEntity timesheet) {

		//ϴ entity ּóѰ͵ Ƚ!
		String sql = "insert into ttimesheet(ts_content,ts_day,ts_month,ts_num,ts_title,ts_type,ts_year,reg_user_id,reg_dtm) values(?,?,?,?,?,?,?,?,?)";

		try {
			conn = DBCPConn.getConnection("pool");
			pstmt = conn.prepareStatement(sql);
			
			pstmt.setString(1, timesheet.getTs_content());
			pstmt.setInt(2, timesheet.getTs_day());
			pstmt.setInt(3, timesheet.getTs_month());
			pstmt.setInt(4, timesheet.getTs_num());
			pstmt.setString(5, timesheet.getTs_title());
			pstmt.setString(6, timesheet.getTs_type());
			pstmt.setInt(7, timesheet.getTs_year());
			pstmt.setString(8, timesheet.getTs_reguser());
			pstmt.setString(9, timesheet.getTs_regdtm());
			// κ
			timesheet.setTs_execute(pstmt.executeUpdate());
		} catch (SQLException e) {
			e.printStackTrace();
			return false;
		} finally {
			try{
				pstmt.close();
				conn.close();
			}catch(SQLException sx) {}
		}

		return true;
	}


	//̹ Ǿ ִ  ϴ 
	public boolean updateDB(TimesheetEntity timesheet) {

		String sql = "update ttimesheet set ts_content=?,ts_day=?,ts_month=?,ts_num=?,ts_title=?,ts_type=?,ts_year=?,last_upd_tm=? where ts_id=?";
	
		try {
			conn = DBCPConn.getConnection("pool");
			pstmt = conn.prepareStatement(sql);
			
			pstmt.setString(1, timesheet.getTs_content());
			pstmt.setInt(2, timesheet.getTs_day());
			pstmt.setInt(3, timesheet.getTs_month());
			pstmt.setInt(4, timesheet.getTs_num());
			pstmt.setString(5, timesheet.getTs_title());
			pstmt.setString(6, timesheet.getTs_type());
			pstmt.setInt(7, timesheet.getTs_year());
			pstmt.setString(8, timesheet.getTs_lastupd());
			pstmt.setInt(9, timesheet.getTs_id());
			
			timesheet.setTs_execute(pstmt.executeUpdate());
		} catch (SQLException e) {
			e.printStackTrace();
			return false;
		} finally {
			try{
				pstmt.close();
				conn.close();
			}catch(SQLException sx) {}
		}

		return true;
	}


	// Խù ϱ  ޼
	public boolean deleteDB(TimesheetEntity timesheet, int ts_id) {

		String sql = "delete from ttimesheet where ts_id=?";

		try {
			conn = DBCPConn.getConnection("pool");
			pstmt = conn.prepareStatement(sql);
			pstmt.setInt(1, ts_id);
			timesheet.setTs_execute(pstmt.executeUpdate());
		} catch (SQLException e) {
			e.printStackTrace();
			return false;
		} finally {
			try{
				pstmt.close();
				conn.close();
			}catch(SQLException sx) {}
		}

		return true;
	}


	
	////߿ ڵ Ǵ ̺  Է½ߵ!!!><><><//////
	// ޼ҵ ̸ ʿ
	public TimesheetEntity get_UserDB(int ts_id) {
		

		String sql = "select * from ttimesheet where ts_id=?";
		TimesheetEntity timesheet = new TimesheetEntity();

		try {
			conn = DBCPConn.getConnection("pool");
			pstmt = conn.prepareStatement(sql);
			pstmt.setInt(1, ts_id);
			ResultSet rs = pstmt.executeQuery();			
			rs.next();
			timesheet.setTs_id(rs.getInt("ts_id"));
			timesheet.setTs_content(rs.getString("ts_content"));
			timesheet.setTs_day(rs.getInt("ts_day"));
			timesheet.setTs_month(rs.getInt("ts_month"));
			timesheet.setTs_num(rs.getInt("ts_num"));
			timesheet.setTs_title(rs.getString("ts_title"));
			timesheet.setTs_type(rs.getString("ts_type"));
			timesheet.setTs_year(rs.getInt("ts_year"));
			timesheet.setTs_reguser(rs.getString("reg_user_id"));



			rs.close();
		} catch (SQLException e) {
			e.printStackTrace();
		} finally {
			try{
				pstmt.close();
				conn.close();
			}catch(SQLException sx) {}
		}

		return timesheet;
	}

	//Խù  ֱ  ϴ ż(͸ Ѳ ´)
	public ArrayList<TimesheetEntity> get_UserDBList() {
		
		ArrayList<TimesheetEntity> datas = new ArrayList<TimesheetEntity>();

		String sql = "select * from ttimesheet ";

		try {
			conn = DBCPConn.getConnection("pool");
			pstmt = conn.prepareStatement(sql);
			ResultSet rs = pstmt.executeQuery();

			while (rs.next()) {
				TimesheetEntity timesheet = new TimesheetEntity();

				timesheet.setTs_id(rs.getInt("ts_id"));
				timesheet.setTs_content(rs.getString("ts_content"));
				timesheet.setTs_day(rs.getInt("ts_day"));
				timesheet.setTs_month(rs.getInt("ts_month"));
				timesheet.setTs_num(rs.getInt("ts_num"));
				timesheet.setTs_title(rs.getString("ts_title"));
				timesheet.setTs_type(rs.getString("ts_type"));
				timesheet.setTs_year(rs.getInt("ts_year"));
				timesheet.setTs_reguser(rs.getString("reg_user_id"));
				datas.add(timesheet);
			}
			rs.close();

		} catch (SQLException e) {
			e.printStackTrace();
		} finally {
			try{
				pstmt.close();
				conn.close();
			}catch(SQLException sx) {}
		}

		return datas;
	}
}
