package robust.pm.util;

/**
 * @(#) DateFormat4Performance.java
 * Copyright 1999-2003 by  Java Service Network Community, KOREA.
 * All rights reserved.  http://www.javaservice.net
 * 
 * NOTICE !      You can copy or redistribute this code freely, 
 * but you should not remove the information about the copyright notice 
 * and the author.
 * 
 * @author  WonYoung Lee, javaservice@hanmail.net
 *
 * modify
 *   - αױ ؼ  ȭϿ ȸѴ.
 *   - ð YYYY/MM/DD HH24:MI.SS  ϵ Ѵ.
 */


public class DateFormat4Performance
{

    private static final int SUPPORTED_YEARS = 30 + 200; // 1970-1999,2000-2199
    private static final int days_month[] = {31,28,31,30,31,30,31,31,30,31,30,31};
    private static long accmulated_timemillis_year[] = new long[SUPPORTED_YEARS]; 
    private static long accmulated_timemillis_month[] = new long[12]; 
    private static long accmulated_timemillis_month_leapyear[] = new long[12]; 
    private static long accmulated_timemillis_2002 = 0L;
    private static int timeZoneOffset = 0;
    /*
    final static char[] digits = { 
    '0' , '1' , '2' , '3' , '4' , '5' , 
    '6' , '7' , '8' , '9'
    };
    */
    final static char [] DigitTens = {
    '0', '0', '0', '0', '0', '0', '0', '0', '0', '0',
    '1', '1', '1', '1', '1', '1', '1', '1', '1', '1',
    '2', '2', '2', '2', '2', '2', '2', '2', '2', '2',
    '3', '3', '3', '3', '3', '3', '3', '3', '3', '3',
    '4', '4', '4', '4', '4', '4', '4', '4', '4', '4',
    '5', '5', '5', '5', '5', '5', '5', '5', '5', '5',
    '6', '6', '6', '6', '6', '6', '6', '6', '6', '6',
    '7', '7', '7', '7', '7', '7', '7', '7', '7', '7',
    '8', '8', '8', '8', '8', '8', '8', '8', '8', '8',
    '9', '9', '9', '9', '9', '9', '9', '9', '9', '9',
    } ; 

    final static char [] DigitOnes = { 
    '0', '1', '2', '3', '4', '5', '6', '7', '8', '9',
    '0', '1', '2', '3', '4', '5', '6', '7', '8', '9',
    '0', '1', '2', '3', '4', '5', '6', '7', '8', '9',
    '0', '1', '2', '3', '4', '5', '6', '7', '8', '9',
    '0', '1', '2', '3', '4', '5', '6', '7', '8', '9',
    '0', '1', '2', '3', '4', '5', '6', '7', '8', '9',
    '0', '1', '2', '3', '4', '5', '6', '7', '8', '9',
    '0', '1', '2', '3', '4', '5', '6', '7', '8', '9',
    '0', '1', '2', '3', '4', '5', '6', '7', '8', '9',
    '0', '1', '2', '3', '4', '5', '6', '7', '8', '9',
    } ;
    static {
        long acc_timemillis = 0L;
        for(int i=0;i<SUPPORTED_YEARS;i++){
            long timemillis_this_year = 0L;
            if ( isLeapYear( 1970+i ) )
                timemillis_this_year = 31622400000L; // 366 * 24 * 60 * 60 * 1000;
            else
                timemillis_this_year = 31536000000L; // 365 * 24 * 60 * 60 * 1000;
            acc_timemillis  += timemillis_this_year;
            accmulated_timemillis_year[i] = acc_timemillis;
            if ( (1970+i) == 2002 ) {
                accmulated_timemillis_2002 = accmulated_timemillis_year[i];
            }
        }

        acc_timemillis = 0L;
        for ( int i=0; i<12;i++){
            acc_timemillis += days_month[i] * 86400000L; // days_month[i] * 24 * 60 * 60 *1000;
            accmulated_timemillis_month[i] = acc_timemillis;
            if ( i < 1 )
                accmulated_timemillis_month_leapyear[i] = accmulated_timemillis_month[i];
            else 
                accmulated_timemillis_month_leapyear[i] = accmulated_timemillis_month[i] + 86400000L;
        }

        timeZoneOffset = java.util.TimeZone.getDefault().getRawOffset();
    }

    private static boolean isLeapYear(int year) {
        return ((year%4 == 0) && ((year%100 != 0) || (year%400 == 0)));
    }


    private DateFormat4Performance()
    {
    }
    
    public static String getCurrentTimestampString()
    {
        return getTimestampString(System.currentTimeMillis());
    }

    public static String getTimestampString(long l)
    {
        l += timeZoneOffset;

        if ( l < 0 ) return "19700101000000";
        if ( l > accmulated_timemillis_year[SUPPORTED_YEARS-1] ) return "99991231000000";
        int year = 9999;
        int mon = 0;
        //boolean leap_year = false;
        if ( l > accmulated_timemillis_2002 ) {
            for(int y=2003;y< (1970+SUPPORTED_YEARS-1); y++){
                if ( l < accmulated_timemillis_year[y-1970] ) {
                    year = y;
                    break;
                }
            }
        }
        else {
            for(int y=1970;y<(1970+SUPPORTED_YEARS); y++){
                if ( l < accmulated_timemillis_year[y-1970] ) {
                    year = y;
                    break;
                }
            }
        }
        if ( year > 1970 ) l -= accmulated_timemillis_year[year-1970-1];
        if ( isLeapYear(year) ) {
            for(int m=0;m<12;m++){
                if ( l < accmulated_timemillis_month_leapyear[m] ) {
                    mon = m;
                    if ( m > 0 ) l -= accmulated_timemillis_month_leapyear[m-1];
                    break;
                }
            }
        }
        else {
            for(int m=0;m<12;m++){
                if ( l < accmulated_timemillis_month[m] ) {
                    mon = m;
                    if ( m > 0 ) l -= accmulated_timemillis_month[m-1];
                    break;
                }
            }
            
        }

        //NOTE: 31*24*60*60*1000 = 2,678,400,000 > INTEGER_MAX
        //int day = (int)(l / 86400000); // (24*60*60*1000); 

        //For LONG type n, n/86400000 equals to following transformations
        //bits    transformation          range
        //----------------------------------------------
        //53      (x*104249992)>>>53      0~172799998
        //54      (x*208499983)>>>54      0~863999998
        //55      (x*416999966)>>>55      0~863999998
        //56      (x*833999931)>>>56      0~11059199999
        //57      (x*1667999862)>>>57     0~5529599999
        //58      (x*3335999724)>>>58     0~2764799999
        //59      (x*6671999448)>>>59     0~1382399999
        //60      (x*13343998896)>>>60    0~691199999
        //61      (x*26687997792)>>>61    0~345599999
        //62      (x*53375995584)>>>62    0~172799999
        //----------------------------------------------
        int day = (int)((l*833999931)>>>56); // (int)(l / 86400000);
        l = l - (day * 86400000L);

        
        //NOTE: 24*60*60*1000 = 86,400,000 < INTEGER_MAX
        int r = (int)l; 

        int hour = 0;
        //hour = r / 3600000; // (60*60*1000);

        //For LONG type n, n/3600000 equals to following transformations
        //bits    transformation          range
        //----------------------------------------------
        //46      (x*19546874)>>>46       0~32399998
        //47      (x*39093747)>>>47       0~169199998 > 86,400,000
        //48      (x*78187494)>>>48       0~169199998
        //49      (x*156374988)>>>49      0~169199998
        //50      (x*312749975)>>>50      0~359999998
        //51      (x*625499949)>>>51      0~831599998
        // ....
        hour = (int)((r*39093747L)>>>47); // hour = r / 3600000
        r = r - (hour * 3600000);

        int min = 0;
        //min = r / 60000; // (60*1000)
        //For LONG type n, n/60000 equals to following transformations
        //bits    transformation          range
        //----------------------------------------------
        //37      (x*2290650)>>>37        0~2999998
        //38      (x*4581299)>>>38        0~8339998 > 3600000
        //39      (x*9162597)>>>39        0~89999998
        //40      (x*18325194)>>>40       0~89999998
        //41      (x*36650388)>>>41       0~89999998
        //42      (x*73300776)>>>42       0~89999998
        //43      (x*146601551)>>>43      0~232799998
        //.....
        min = (int)((r*4581299L)>>>38); // min = r / 60000;
        r = r - (min * 60000);
        
        int sec = 0;
        //sec = r / 1000;
        //For INT type n, n/60000 equals to following transformations
        //bits    transformation          range
        //----------------------------------------------
        //24      (x*16778)>>>24  0~21998
        //25      (x*33555)>>>25  0~59998
        //26      (x*67109)>>>26  0~63999 > 60000
        //27      (x*134218)>>>27 0~31999
        //28      (x*268436)>>>28 0~15999
        //.....
        sec = (r*67109)>>>26; // sec = r / 1000;

        //--------------------
        char buf [] = new char [8 + 6];

        /*
        int q = 0;
        for (int p=3;p>=0;p--) { 
            q = (year * 52429) >>> (16+3) ;    // q = year/10
            r = year - ((q << 3) + (q << 1)) ; // r = year-(q*10) ...
            buf [p] = digits [r] ; 
            year = q ; 
            if (year == 0) break ; 
        }
        */
        // I found the following transformation,
        // x/100 --> (x*83887)>>>23  for 0~51199.
        int century = (year*83887)>>>23;
        buf[0] =  DigitTens[century];
        buf[1] =  DigitOnes[century];
        int year_r = year - century*100;
        buf[2] =  DigitTens[year_r];
        buf[3] =  DigitOnes[year_r];

        buf[4] = DigitTens[++mon];
        buf[5] = DigitOnes[mon];

        buf[6] = DigitTens[++day];
        buf[7] = DigitOnes[day];

        buf[8] = DigitTens[hour];
        buf[9] = DigitOnes[hour];

        buf[10] = DigitTens[min];
        buf[11] = DigitOnes[min];

        buf[12] = DigitTens[sec];
        buf[13] = DigitOnes[sec];

        return new String ( buf );
    }
    
    public static String getCurrentTimestampStringFormat()
    {
        return getCurrentTimestampStringFormat(System.currentTimeMillis());
    }

    public static String getCurrentTimestampStringFormat(long l)
    {
        l += timeZoneOffset;

        if ( l < 0 ) return "1970/01/01 00:00.00";
        if ( l > accmulated_timemillis_year[SUPPORTED_YEARS-1] ) return "9999/12/31 00:00.00";
        int year = 9999;
        int mon = 0;
        //boolean leap_year = false;
        if ( l > accmulated_timemillis_2002 ) {
            for(int y=2003;y< (1970+SUPPORTED_YEARS-1); y++){
                if ( l < accmulated_timemillis_year[y-1970] ) {
                    year = y;
                    break;
                }
            }
        }
        else {
            for(int y=1970;y<(1970+SUPPORTED_YEARS); y++){
                if ( l < accmulated_timemillis_year[y-1970] ) {
                    year = y;
                    break;
                }
            }
        }
        if ( year > 1970 ) l -= accmulated_timemillis_year[year-1970-1];
        if ( isLeapYear(year) ) {
            for(int m=0;m<12;m++){
                if ( l < accmulated_timemillis_month_leapyear[m] ) {
                    mon = m;
                    if ( m > 0 ) l -= accmulated_timemillis_month_leapyear[m-1];
                    break;
                }
            }
        }
        else {
            for(int m=0;m<12;m++){
                if ( l < accmulated_timemillis_month[m] ) {
                    mon = m;
                    if ( m > 0 ) l -= accmulated_timemillis_month[m-1];
                    break;
                }
            }
            
        }

        //NOTE: 31*24*60*60*1000 = 2,678,400,000 > INTEGER_MAX
        //int day = (int)(l / 86400000); // (24*60*60*1000); 

        //For LONG type n, n/86400000 equals to following transformations
        //bits    transformation          range
        //----------------------------------------------
        //53      (x*104249992)>>>53      0~172799998
        //54      (x*208499983)>>>54      0~863999998
        //55      (x*416999966)>>>55      0~863999998
        //56      (x*833999931)>>>56      0~11059199999
        //57      (x*1667999862)>>>57     0~5529599999
        //58      (x*3335999724)>>>58     0~2764799999
        //59      (x*6671999448)>>>59     0~1382399999
        //60      (x*13343998896)>>>60    0~691199999
        //61      (x*26687997792)>>>61    0~345599999
        //62      (x*53375995584)>>>62    0~172799999
        //----------------------------------------------
        int day = (int)((l*833999931)>>>56); // (int)(l / 86400000);
        l = l - (day * 86400000L);

        
        //NOTE: 24*60*60*1000 = 86,400,000 < INTEGER_MAX
        int r = (int)l; 

        int hour = 0;
        //hour = r / 3600000; // (60*60*1000);

        //For LONG type n, n/3600000 equals to following transformations
        //bits    transformation          range
        //----------------------------------------------
        //46      (x*19546874)>>>46       0~32399998
        //47      (x*39093747)>>>47       0~169199998 > 86,400,000
        //48      (x*78187494)>>>48       0~169199998
        //49      (x*156374988)>>>49      0~169199998
        //50      (x*312749975)>>>50      0~359999998
        //51      (x*625499949)>>>51      0~831599998
        // ....
        hour = (int)((r*39093747L)>>>47); // hour = r / 3600000
        r = r - (hour * 3600000);

        int min = 0;
        //min = r / 60000; // (60*1000)
        //For LONG type n, n/60000 equals to following transformations
        //bits    transformation          range
        //----------------------------------------------
        //37      (x*2290650)>>>37        0~2999998
        //38      (x*4581299)>>>38        0~8339998 > 3600000
        //39      (x*9162597)>>>39        0~89999998
        //40      (x*18325194)>>>40       0~89999998
        //41      (x*36650388)>>>41       0~89999998
        //42      (x*73300776)>>>42       0~89999998
        //43      (x*146601551)>>>43      0~232799998
        //.....
        min = (int)((r*4581299L)>>>38); // min = r / 60000;
        r = r - (min * 60000);
        
        int sec = 0;
        //sec = r / 1000;
        //For INT type n, n/60000 equals to following transformations
        //bits    transformation          range
        //----------------------------------------------
        //24      (x*16778)>>>24  0~21998
        //25      (x*33555)>>>25  0~59998
        //26      (x*67109)>>>26  0~63999 > 60000
        //27      (x*134218)>>>27 0~31999
        //28      (x*268436)>>>28 0~15999
        //.....
        sec = (r*67109)>>>26; // sec = r / 1000;

        //--------------------
        char buf [] = new char [8 + 5 + 6];

        /*
        int q = 0;
        for (int p=3;p>=0;p--) { 
            q = (year * 52429) >>> (16+3) ;    // q = year/10
            r = year - ((q << 3) + (q << 1)) ; // r = year-(q*10) ...
            buf [p] = digits [r] ; 
            year = q ; 
            if (year == 0) break ; 
        }
        */
        // I found the following transformation,
        // x/100 --> (x*83887)>>>23  for 0~51199.
        int century = (year*83887)>>>23;
        buf[0] =  DigitTens[century];
        buf[1] =  DigitOnes[century];
        int year_r = year - century*100;
        buf[2] =  DigitTens[year_r];
        buf[3] =  DigitOnes[year_r];
        
        buf[4] = '/';

        buf[5] = DigitTens[++mon];
        buf[6] = DigitOnes[mon];
        
        buf[7] = '/';

        buf[8] = DigitTens[++day];
        buf[9] = DigitOnes[day];

        buf[10] = ' ';

        buf[11] = DigitTens[hour];
        buf[12] = DigitOnes[hour];
        
        buf[13] = ':';

        buf[14] = DigitTens[min];
        buf[15] = DigitOnes[min];
        
        buf[16] = '.';

        buf[17] = DigitTens[sec];
        buf[18] = DigitOnes[sec];

        return new String ( buf );
    }

    // Performance Test
    public static void main(String[] args) throws Exception {
        int MAX=100000;

        java.text.SimpleDateFormat df = new java.text.SimpleDateFormat("yyyyMMdd/HHmmss");
        // initialize static variables
        new java.util.Date();
        DateFormat4Performance.getCurrentTimestampString();

        long s = System.currentTimeMillis();
        for(int i=0;i<MAX;i++){
            df.format(new java.util.Date());
        }
        long e = System.currentTimeMillis();
        //System.out.println("1 : " + (e-s));

        s = System.currentTimeMillis();
        for(int i=0;i<MAX;i++){
            DateFormat4Performance.getCurrentTimestampString();
            //DateFormat4Performance.getTimestampString(System.currentTimeMillis());
        }
        e = System.currentTimeMillis();
        //System.out.println("2 : " + (e-s));

        //System.out.println(DateFormat4Performance.getCurrentTimestampString());

    }
}
